class Vertex implements Comparable {

  public final char value;
  public final boolean isRoot;
  // minWeight used for makeMinimalSpanningTree and makeShortestPath
  public int minWeight = 0;
  // TODO: add further fields if required

  public Vertex(char value) {
    this(value, false);
  }

  public Vertex(char value, boolean isRoot) {
    this.value = value;
    this.isRoot = isRoot;
  }

  public int compareTo(Object obj) {
    Vertex v = (Vertex) obj;
    int diff = v.minWeight - this.minWeight;
    if (diff != 0) {
      return diff;
    } else {
      return this.value - v.value;
    }
  }

  public boolean equals(Object obj) {
    return compareTo(obj) == 0;
  }

  public int hashCode() {
    return value;
  }
}
